
package de.ivu.elect.presentation.wahlbeteiligung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungBoundaryCreate;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractWahlbeteiligungAuswertungCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungAuswertungCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_CREATE)
public abstract class AbstractWahlbeteiligungAuswertungCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<WahlbeteiligungAuswertung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungAuswertungCreateView";

  public static final String VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-auswertung-create.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-auswertung-search.xhtml";

  @Inject
  protected transient WahlbeteiligungAuswertungBoundaryCreate create;

  protected WahlbeteiligungAuswertung entity;

  @Inject
  protected transient WahlbeteiligungAuswertungMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  WahlbeteiligungAuswertung());
  }

  

  public WahlbeteiligungAuswertung getEntity() {
    return entity;
  }

  protected void setEntity(WahlbeteiligungAuswertung entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(WahlbeteiligungAuswertung entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(WahlbeteiligungAuswertung entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
